/* all teh code for gettting a stream from a remote site is in here */
#include "mp3serv.h"

void get_livestream(int sd,config conf,FILE *mnt){
unsigned char buffer[2048],c;
int len,bptr;
FILE *out;
unsigned long header;

if((out=fopen(conf.header_file,"wb"))==NULL)
  fatal("creating header file");

/* strip any html header garbage off the front */
/* hope this reordering doens't get too confusing */
bptr=0;
read(sd,buffer,4);
header=((unsigned long) buffer[0] << 24) | ((unsigned long) buffer[1] << 16) |  ((unsigned long) buffer[2] << 8)  | (unsigned long) buffer[3];
while(!valid(header)){
  read(sd,&c,1);
  header <<= 8;
  header |= (unsigned long) c;
  header &= 0xffffffff;
  bptr++;
  if(bptr>1024)
    fatal("mp3 header seek1");
}
buffer[0]=(header>>24)&0xff;
buffer[1]=(header>>16)&0xff;
buffer[2]=(header>>8)&0xff;
buffer[3]=header&0xff;
/*ok that's the start of our file */
read(sd,&buffer[4],2044);
/*ok so buffer now contains something which looks like it stats on a frame*/
/* now start from the middle of the buffer and lok for another frame      */
/* boundary - this is not intelligent - really we should read the frame   */
/* headers and work out the sizes properly                                */
bptr=1024;
header=((unsigned long) buffer[1024] << 24) | ((unsigned long) buffer[1025] << 16) |  ((unsigned long) buffer[1026] << 8)  | (unsigned long) buffer[1027];
while(!valid(header)){
  c=buffer[bptr+4];
  bptr++;
  header <<= 8;
  header |= (unsigned long) c;
  header &= 0xffffffff;
  if(bptr>2048)
    fatal("mp3 header seek2");
}
fwrite(buffer,1,bptr,out);
fclose(out);
/* OK now we hopefully should have a header in header.mp3                */
/* now start writing to live.mp3                                         */

if((out=fopen(conf.live_file,"wb"))==NULL)
  fatal("creating live file");

fwrite(buffer,1,2048,out);
while(1){
  arm(30);
  len=read(sd,buffer,2048);
  if(len==-1)
    fatal("reading data from remote server");
  fwrite(buffer,1,len,out);
}

}




void get_server_feed(config conf){
  sckt *sp;
  int sd;
  FILE *mnt;
  fprintf(stderr,"Opening remote server feed\n");
  /* open pipe for talking to maintenance process */
  if((mnt=fopen(conf.mnt_pipe,"w"))==NULL)
    fatal("unable to open mnt_pipe for getting remote server feed");
  fprintf(mnt,"%6d:R %s %d\n",getpid(),conf.reflector,conf.reflector_port);

  /*generate a socket*/
  if ((sp = sopen())==0)
    fatal("sopen() - get remnote stream");
  /* Make contact with server */ 
  if ((sd = sclient(sp,conf.reflector,conf.reflector_port))==-1)
    fatal("sclient() - get remote stream");
  get_livestream(sd,conf,mnt);
  sclose(sp);
  exit(0);
}
