/* The maintenance process makes sure that the server doesn't get overloaded*/
/* it also maintains the incoming data from the encoder and shuts down      */
/* everythign at the end                                                    */
/* all interprocess communication takes place via a named pipe              */
/* SImple version right now just dumps every report string to the log file  */

#include "mp3serv.h"

void report(char *str,FILE *mnt){
fprintf(mnt,"%6d:%s\n",getpid(),str);
}


void maintain_server(config conf){
FILE *pipe,*log;
int pnum;
char str[1024];

pipe=fopen(conf.mnt_pipe,"r");
log=fopen(conf.log_file,"a");
while(1){
  fscanf(pipe,"%d:%[^\n]",&pnum,str);
  fprintf(log,"%s\n",str);
  fflush(log);
}

}
