/* this file spawns a process to write to a pipe and spwans l3enc to read */
/* from this pipe */
/* This now semi appears to work */

#include "mp3serv.h"
#include <sys/soundcard.h>

#define BUF_LENGTH 256
#define BUF_SIZE BUF_LENGTH*2
#define BUFLEN 1024*32

void read_soundcard(config conf,FILE *mnt){
int format,stereo,speed,len,blksize,i,j,k,mode,clip;
int audio_fd,audio_play_rate,vol;
short audiobuf[4096];
FILE *pipe;

if((audio_fd=open("/dev/dsp",O_RDONLY))==-1)
  fatal("Failed to open sound device");
ioctl(audio_fd, SNDCTL_DSP_GETFMTS, &format);  
if(!(format&AFMT_S16_LE))
  printf("16bit mode not supported\n");
format = AFMT_S16_LE;
if(ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format)==-1)
  fatal("Failed to set data format\n");
stereo=0;
if(ioctl(audio_fd,SNDCTL_DSP_STEREO,&stereo)==-1)
  fatal("Somethign went wrong with the stereo setting");
audio_play_rate=22050;
if(ioctl(audio_fd,SNDCTL_DSP_SPEED,&audio_play_rate)==-1)
  fatal("Speed Setting failed");

if((pipe=fopen(conf.snd_pipe,"wb"))==NULL)
  fatal("opening raw audio pipe for writing sound");

while(1){
  read(audio_fd,audiobuf,2*4096);
  fwrite(audiobuf,2,4096,pipe);
  vol=0;
  clip=0;
  for(i=0;i<4096;i++){
    if(abs(audiobuf[i])>vol)
      vol=abs(audiobuf[i]);
  }
  /* this is bigger so that it shows through the encoders output */
  fprintf(stderr,"\r                               \r%d ",vol);
  if(vol>32000)
    fprintf(stderr,"******clip*********");
}
close(audio_fd);
fprintf(stderr,"\n");
}

void exec_encoder(config conf,FILE *mnt){
/* bugger! the output form l3enc zaps the level meter */
execlp("l3enc","l3enc",conf.snd_pipe,conf.live_file,"-br","16000","-sr","22050","-tfc","1","-dm",NULL);
fatal("failed to launch l3enc");
}

/* forget this for thie moment - use the outside server */
void start_recording(config conf){
FILE *mnt,*snd;
if((mnt=fopen(conf.mnt_pipe,"w"))==NULL)
  fatal("opening mnt_pipe while spawning encoder");
switch (fork())
      {
      case 0:
	exec_encoder(conf,mnt);    
      case -1:
	fatal("fork() - with encoder");
      }

read_soundcard(conf,mnt);

}
